/***************************************************

Abstract class to connect to the servlet and get data.

***************************************************/

function MyXMLHttpRequest()
{
   //Empty public properties.
}

//Method to emulate the creation of an XMLHttpRequest object.
MyXMLHttpRequest.getXMLHttpRequest = function()
{
   if(window.XMLHttpRequest === undefined)
   {
      try
      {
	 //Use the latest version of the ActiveX object if available.
	 return new ActiveXObject("Msxml2.XMLHTTP.6.0");
      }
      catch(e1)
      {
	 try
	 {
	    //Otherwise, fall back on an older version.
	    return new ActiveXObject("Msxml2.XMLHTTP.3.0");
	 }
	 catch(e2)
	 {
	    //Throw an error.
	    throw new Error("XMLHttpRequest is not supported.");
	 }
      }
   }
   else
      return new XMLHttpRequest();
}
   
//Method to send and get data from the server response.
MyXMLHttpRequest.getData = function(url, data, callback, object)
{
   var request = MyXMLHttpRequest.getXMLHttpRequest();		//Create a request object.
   request.open("GET", url + "?q=" + encodeURIComponent(data));		//Encode data.
   request.onreadystatechange = function()
   {
      if(request.readyState === 4 && callback && object)		//Event handler.
      {
	 callback(request, object);					//Return the XML response.
      }
   };
   request.send(null);						//Send the request.
}

