/*********************************************************************

Class Suggestion to generate an array of google suggestions by 
communicating via our proxy servlet.

*********************************************************************/

function Suggestion()
{
   this.objContainer = null;		//Store its AutoSuggestControl parent.
   this.flagTypeAhead = false;		//Determines if type ahead is active.
}

//Function to get an array of suggestions.
Suggestion.prototype.requestSuggestions = function(oAutoSuggestControl, bTypeAhead)
{
   var query = oAutoSuggestControl.textBox.value;
   this.objContainer = oAutoSuggestControl;
   this.flagTypeAhead = bTypeAhead;
   
   if(query.length > 0)				//Perform autosuggest only if query is given.
      MyXMLHttpRequest.getData("suggest", query, Suggestion.parseXML, this);	//Pass also a reference to object.
   else
      this.objContainer.autosuggest([], false);	//Indicate the container to hide previously shown layer.
}

//Function to parse the xml response from the server (called asynchronously).
Suggestion.parseXML = function(request, object)
{
   //Get the xml string.
   var xmlString = request.responseXML;

   //Get the complete suggestions from the input.
   var s = xmlString.getElementsByTagName("CompleteSuggestion");
   
   //Fill in the suggestions array.
   var results = new Array();
   for(I=0; I<s.length; I++)
   {
      results[I] = s[I].childNodes[0].getAttribute("data");
   }
   
   //Perform autosuggest asynchronously.
   object.objContainer.autosuggest(results, object.flagTypeAhead);
}
