/* Function to decode the address to show in the google map */
function codeAddress() 
{
   geocoder = new google.maps.Geocoder();
   var latlng = new google.maps.LatLng(19.47, -103.306);	//Default location: Mexico.
   var myOptions = 
   {
      zoom: 2,
      center: latlng,
      mapTypeId: google.maps.MapTypeId.ROADMAP
   }
   var map = new google.maps.Map(document.getElementById("mapCanvas"), myOptions);	//Default map.

   var address = document.getElementById("address").value;
   geocoder.geocode( { 'address': address}, 
      function(results, status)
      {
         if(status == google.maps.GeocoderStatus.OK)
	 {
            map.setCenter(results[0].geometry.location);
	    map.setZoom(8);
            var marker = new google.maps.Marker({
               map: map,
               position: results[0].geometry.location
            });
         }
      });
}

/* Functions to perform the population of an array of suggestions via Ajax */
function Suggestion()
{
   this.xmlHttpRequest;		//Private request object to servlet.
   this.suggestions;		//Array of results.
   this.request = "suggest?q=";	//URL for requesting to the servlet.
   
   this.init();			//Initialize object.
}

Suggestion.prototype.init = function()
{
   var oThis = this;			//Save reference to current class's object.
   this.xmlHttpRequest = new XMLHttpRequest();
   
   this.xmlHttpRequest.onreadystatechange = function()
   {
      if(oThis.xmlHttpRequest.readyState == 4)	//Reception of response?
      {
         oThis.suggestions = oThis.populateSuggestions(oThis.xmlHttpRequest.responseXML);
      }
   };
}

Suggestion.prototype.populateSuggestions = function(xmlString)
{
   //Get the complete suggestions from the input.
   var s = xmlString.getElementsByTagName("CompleteSuggestion");
   
   //Fill in the suggestions array.
   var myArray = new Array();
   for(I=0; I<s.length; I++)
   {
      myArray[I] = s[I].childNodes[0].getAttribute("data");
   }
   
   return myArray;		//Return the array of suggestions.
}

Suggestion.prototype.requestSuggestions = function(query)
{
   this.xmlHttpRequest.open("GET", this.request + encodeURI(query));	//Open connection with servlet.
   this.xmlHttpRequest.send(null);	//Send request.
   //At this point, suggestions contains the response from the servlet.
}
