<%@ page import = "edu.ucla.cs.cs144.*" %>
<jsp:useBean id="itemBean" scope="request" type="edu.ucla.cs.cs144.ItemBean" />

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml/DTD/xhtml-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
   <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
   <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />	<!-- For using google maps API -->
   <link href="style.css" rel="stylesheet" type="text/css" />
   
   <title>eBay | Item Data</title>
   
   <script type="text/javascript"
      src="http://maps.googleapis.com/maps/api/js?sensor=false">		<!-- Google maps API javascript libray -->
   </script>
   <script type="text/javascript"
      src="code.js">
   </script>

   
</head>

<body onload="codeAddress();">
   <div id="container">			<!-- The main container -->
   
      <div id="authorship">
         <p>Luis Angel Larios Cardenas &copy; 2011</p>
	 <p><a class="homeLink" href="index.html">Home Page</a></p>
      </div>
      
      <div id="searchBox2">		<!-- Form to catch a different query -->
         <form action="item" method="get">
            <input id="searchField" type="text" name="id" />
	    <input id="searchButton" type="submit" value="Get Item!">
         </form>
      </div>
      
      <div id="resultsList">
      
         <%
	 String id = request.getParameter("id");	//Get the id parameter from request.
	 
	 out.println("<p class='notification'>Data for Auction: <span style='font-weight:bold; font-size:1.3em;'>" + id + "</span></p>");
      
         if(itemBean.getItemID().length() == 0)		//No result element?
           out.println("<p class='text'>The item you are trying to display does not exist, please correct any mistake.</p>");
         else
         {
	   out.println("<div id='colWrap'>");//Print categories to the left, together with the google map.
	      String[] categories = itemBean.getCategories();
              int I = 0;
	      out.println("<table class='colTable'>");
	      out.println("<tr><td class='blueTop'>Categories</td></tr>");
	      out.println("<tr><td class='blueBody'>");
	      out.println("<ul>");
	      while(I < categories.length)	//Iterate over all categories.
	      {
	        out.println("<li style='margin:3px 3px 3px 15px;'>" + categories[I] + "</li>"); 
	        I++;
	      }
	      out.println("</ul>");
	      out.println("</td></tr>");
	      out.println("</table>");
	      
	      out.println("<div class='grayDiv' style='margin-bottom: 0;'>");
	      User seller = itemBean.getSeller();
	      out.println("<p style='margin:3px;'><b>Seller</b> " + seller.getUserID() + "</p>");
	      out.println("<p style='margin:3px; font-weight:bold;'>Rating: <span style='color: #005500;'>" + seller.getRating() + "</span></p>");
	      out.println("<p style='margin:3px;'>" + seller.getLocation() + ", " + seller.getCountry() + "</p>");
	      out.println("</div>");
	      
	      ///////////// Section to pass the address to the javascript function ///////////////

	      out.println("<input type='hidden' id='address' value='" + seller.getLocation() + ", " + seller.getCountry() + "'/>");

	      ////////////////////////////////////////////////////////////////////////////////////
	      
	      out.println("<div id='mapCanvas'></div>");			//Canvas for the google map.
	      
	   out.println("</div>");
	   
	   out.println("<div id='itemDescWrap'>");	//Name and description in the center.
	      out.println("<p class='title'>" + itemBean.getName() + "</p>");
	      out.println("<div id='descDiv'>" + itemBean.getDescription() + "</div>");
	   out.println("</div>");
	   
	   out.println("<div id='colWrap'>");//Other data to the right.
	      out.println("<table class='colTable'>");
	      out.println("<tr><td class='grayTop'>Auction Dates</td></tr>");
	      out.println("<tr><td class='grayBody'>");
	      out.println("<p style='margin:3px;'><b>Started:</b> " + itemBean.getStarted() + "</p>");
	      out.println("<p style='margin:3px;'><b>Ends: </b>" + itemBean.getEnds() + "</p>");
	      out.println("</td></tr>");
	      out.println("</table>");
	      
	      out.println("<table class='colTable'>");
	      out.println("<tr><td class='blueTop'>Currently: " + itemBean.getCurrently() + "</td></tr>");
	      out.println("<tr><td class='blueBody'>");
	      
	      if(itemBean.getBuyPrice().length()>0)
	      {
	        out.println("<p style='margin:3px;'><b>Buy Price: </b>" + itemBean.getBuyPrice() + "</p>");
	      }
	      
	      out.println("<p style='margin:3px;'><b>First Bid: </b>" + itemBean.getFirstBid() + "</p>");
	      out.println("<p style='margin:3px;'><b>Number of Bids: </b>" + itemBean.getNumberOfBids() + "</p>");
	      out.println("</td></tr>");
	      out.println("</table>");
	      
	      if(itemBean.getBuyPrice().length()>0)
	      {
	        out.println("<div class='grayDiv' style='margin-bottom: 0; padding: 13px 0px;'>");
		out.println("<p style='margin:3px;'><a href='payment?itemID=" + itemBean.getItemID() + "' class='redLink'>Pay Now!</a></p>");  //Show a button to buy it.
		out.println("</div>");
	      }
	   out.println("</div>");
	   
	   Bid[] bids = itemBean.getBids();
           if(bids.length > 0)
	   {
	     I = 0;
	     
	     out.println("<div id='bidsDiv'>");
	     
	     out.println("<table class='bidsTable'>");			//Print table of bids.
	     out.println("<tr><td class='top'>Bidder</td>");		//Print col titles.
	     out.println("<td class='top'>Rating</td>");
	     out.println("<td class='top'>Location</td>");
	     out.println("<td class='top'>Time</td>");
	     out.println("<td class='top'>Amount</td>");
	     out.println("</tr>");
	     
	     while(I < bids.length)	//Iterate over all bids.
	     {
	       User bidder = bids[I].getBidder();
	       out.println("<tr>");
	       out.println("<td class='bidder'>" + bidder.getUserID() + "</td>");
	       out.println("<td class='rating'>" + bidder.getRating() + "</td>");
	       out.println("<td class='location'>" + bidder.getLocation() + ", " + bidder.getCountry() + "</td>");
	     
	       out.println("<td class='time'>" + bids[I].getTime() + "</td>");
	       out.println("<td class='amount'>" + bids[I].getAmount() + "</td>");
	       out.println("</tr>");
	       I++;
	     }
	     
	     out.println("</table>");
	     
	     out.println("</div>");
	   }
         }
         %>
	 
      </div>
      
   </div>				<!-- Ends the container -->
</body>

</html>
