<%@ page import = "edu.ucla.cs.cs144.*" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml/DTD/xhtml-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
   <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
   <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable = no" />
   <link href="android.css" rel="stylesheet" type="text/css" media="screen and (max-device-width: 480px)" />
   <link href="style.css" rel="stylesheet" type="text/css" media="not screen and (max-device-width: 480px)" />
   
   <title>eBay | Basic Search</title>
   
   <script type="text/javascript" src="MyXMLHttpRequest.js"></script>
   <script type="text/javascript" src="Suggestion.js"></script>
   <script type="text/javascript" src="AutoSuggestControl.js"></script>
   <script type="text/javascript">
   var oTextbox = null;
   
   window.onload = function()
   {
      oTextbox = new AutoSuggestControl(document.getElementById("searchField"), new Suggestion()); 
   }
   
   window.onresize = function()
   {
      if(oTextbox != null && oTextbox.backField != null)
      {
         oTextbox.backField.style.left = oTextbox.getLeft() + "px";
         oTextbox.backField.style.top = oTextbox.getTop() + "px";
	 oTextbox.backField.style.width = (oTextbox.textBox.offsetWidth - 3) + "px";
	 oTextbox.layer.style.width = (oTextbox.textBox.offsetWidth-2) + "px";
      }
   }
   </script>
</head>

<body>
   <div id="container">			<!-- The main container -->
   
      <div id="authorship">
         <p>Luis Angel Larios Cardenas &copy; 2011</p>
	 <p><a class="homeLink" href="index.html">Home Page</a></p>
      </div>
      
      <div id="backField"></div>
      
      <div id="searchBox2">		<!-- Form to catch a different query -->
         <form action="search" method="get">
            <input id="searchField" type="text" name="q" autocomplete="off" />
	    <input type="hidden" name="numResultsToSkip" value="0" />
	    <input type="hidden" name="numResultsToReturn" value="0" />
	    <input id="searchButton" type="submit" value="Find it!">
         </form>
      </div>
      
      <div id="resultsList">
      
         <%
         SearchResult[] searchResults = (SearchResult[])request.getAttribute("searchResults");	//Get the results from the request implicit object.
	 int totalResults = 0;									//Get the total number of results.
	 int numResultsToSkip = Integer.parseInt(request.getParameter("numResultsToSkip"));	//Get request parameters.
	 int numResultsToReturn = Integer.parseInt(request.getParameter("numResultsToReturn"));
	 String q = request.getParameter("q");
	 QueryBean[] queries = (QueryBean[])session.getAttribute("queries");			//Extract the queries array.
	 
	 //////////// Look for the total number of results for current query //////////////
	 for(int I=0; I < queries.length; I++)
	 {
	    //out.println("Query: " + queries[I].getQuery() + " | Results: " + queries[I].getTotalResults());
	    if(queries[I].getQuery().equals(q.trim().toLowerCase().replaceAll("( )+", " ")))	//Found it?
	       totalResults = queries[I].getTotalResults();
	 }
	 
	 //////////// Set apropriate values for numResultsToSkip and numResultsToReturn ////////////
	 //// Verifying that num results to skip is multiple of 10 for proper display ////
	 if(numResultsToSkip % 10 != 0)
	    numResultsToSkip = ((int)(numResultsToSkip/10))*10;	//Round it to lower int.
	 if(numResultsToSkip < 0)						//Negative number?
	    numResultsToSkip *= -1;						//Change sign.

	 //////// Verifying that numResultsToReturn is either 0 or 10 ////////
	 if(numResultsToReturn != 0 && numResultsToReturn != 10)
	    numResultsToReturn = 10;
         
	 out.println("<p class='notification'>Number of Results: <span style='font-weight:bold; font-size:1.2em;'>" + totalResults + "</span><br />");
 	 out.println("Query: <span style='font-weight:bold; font-size:1.3em;'>" + q + "</span></p>");
      
         if(totalResults == 0)		//No result elements?
           out.println("<p class='text'>No results were found, please refine your search</p>");
         else
         {
           int I = 0;
	   while(I < searchResults.length && I < 10)	//Iterate over all results (first call check also numResultsToReturn)
	   {
	     out.println("<p class='text'><a href='item?id=" + searchResults[I].getItemId() + "' class='link'>" + searchResults[I].getItemId() + "</a></p>"); 
	     out.println("<p class='text'>" + searchResults[I].getName() + "</p>");
	     out.println("<br />");
	     I++;
	   }
	   
	   if(numResultsToSkip + 10 < totalResults || numResultsToSkip - 10 >= 0)	//Check for need of the footer.
	   {
	     out.println("</div>");		//Close the results list div.
	     
	     out.println("<div id='footer'>");	//Open footer div.
	     out.println("<table style='border-collapse:collapse; width: 100%;'>");
	     out.println("<tr>");
	   
	     //Determine previous set of results to show.
	     if(numResultsToSkip - 10 >= 0)		//Are previous results?
	     {
	       out.println("<td style='text-align: center;'>");
	       out.println("<a class='footLink' href='search?q="+ q +"&numResultsToSkip="+ (numResultsToSkip-10) +"&numResultsToReturn=10'>Previous Page</a>");  
	       out.println("</td>");
	     }
	       
	     //Determine next set of results to show.
	     if(numResultsToSkip + 10 < totalResults)	//Are there still results to show?
	     {
	       out.println("<td style='text-align: center;'>");
	       out.println("<a class='footLink' href='search?q="+ q +"&numResultsToSkip="+ (numResultsToSkip+10) +"&numResultsToReturn=10'>Next Page</a>");
	       out.println("</td>");
	     }
	     
	     out.println("</tr>");
	     out.println("</table>");  
	     out.println("</div>");		//Close the footer div.  
	   }
	   else
	     out.println("</div>");		//Simply Close the results list div.
         }
         %>
      
   </div>				<!-- Ends the container -->
</body>

</html>
