#!/bin/bash
  
# Run the drop.sql batch file to drop existing tables 
mysql CS144 < drop.sql
  
# Run the create.sql batch file to create the database and tables
mysql CS144 < create.sql

# Compile and run the parser to generate the appropriate load files
ant
ant run-all

# If the Java code does not handle duplicate removal, do this now
sort userLocRelation.txt -o userLocSorted.txt
uniq userLocSorted.txt userLocRelation.txt
sort userCountryRelation.txt -o userCountrySorted.txt
uniq userCountrySorted.txt userCountryRelation.txt
sort userRatingRelation.txt -o userRatingSorted.txt
uniq userRatingSorted.txt userRatingRelation.txt
sort itemCategoryRelation.txt -o itemCategorySorted.txt
uniq itemCategorySorted.txt itemCategoryRelation.txt

# Run the load.sql batch file to load the data
mysql CS144 < load.sql

# Remove all temporary files
rm bidInfoRelation.txt
rm itemBuyPriceRelation.txt
rm itemCategoryRelation.txt
rm itemCategorySorted.txt
rm itemRelation.txt
rm userCountryRelation.txt
rm userCountrySorted.txt
rm userLocRelation.txt
rm userLocSorted.txt
rm userRatingRelation.txt
rm userRatingSorted.txt
rm -r bin
