package edu.ucla.cs.cs144;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;

public class ItemServlet extends HttpServlet implements Servlet {
       
    public ItemServlet() {}

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	if(request.getParameter("id")==null)			//Check that id was received.
    		response.sendRedirect("getItem.html");
    	else
    	{
    		String id = request.getParameter("id");			//Retrieve the item id.
            
            id = id.trim();									//Remove the spaces to left and right.
            if(id.length() != 0)							//Id was provided?
            {
            	String xmlData = AuctionSearchClient.getXMLDataForItemId(id);	//Get XML data.
            	ItemBean itemBean = new ItemBean();
            	MyParser myParser = new MyParser();
            	
            	if(xmlData!=null && xmlData.length()!=0)
            		itemBean = myParser.processXMLString(xmlData);					//Fill in the bean fields.
            	
               	request.setAttribute("itemBean", itemBean);						//Forward a bean to a JSP.
                request.getRequestDispatcher("itemData.jsp").forward(request, response);
            }
            else
            	response.sendRedirect("getItem.html");
    	}
    }
}
