package edu.ucla.cs.cs144;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.*;
import java.util.Vector;

public class ItemServlet extends HttpServlet implements Servlet {
       
    public ItemServlet() {}

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	PrintWriter salida = response.getWriter();
    	
    	//////////////////////////////Validate that this page is http ///////////////////////////
    	//Construct the http redirection.
    	String scheme = "http";             			// http.
        String serverName = request.getServerName();    // localhost.
        int serverPort = 8080;       					// Unsecure port.
        String contextPath = request.getContextPath();  // /eBay
        String servletPath = request.getServletPath();	// Back to unencrypted navigation.
        String query = request.getQueryString();		// Get the query parameters.
        String url = scheme + "://" + serverName+":" + serverPort + contextPath + servletPath;
        url += (query != null)? "?"+query : "";
        if(request.isSecure())							// Is request for a secure connection?
        {
        	salida.println("You will be redirected to a valid http, not cyphered, version of this page.");
        	response.sendRedirect(url);					// Load the equivalent http page.
        }
        /////////////////////////////////////////////////////////////////////////////////////////
        else
        {
        	if(request.getParameter("id")==null)			//Check that id was received.
        		response.sendRedirect("getItem.html");
        	else
        	{
        		String id = request.getParameter("id");			//Retrieve the item id.    		
                
                id = id.trim();									//Remove the spaces to left and right.
                if(id.length() != 0)							//Id was provided?
                {
                	String xmlData = AuctionSearchClient.getXMLDataForItemId(id);	//Get XML data.
                	ItemBean itemBean = new ItemBean();
                	MyParser myParser = new MyParser();
                	HttpSession session;						//Session to store item data.
                	PurchaseBean purchaseBean = new PurchaseBean();	//To store probable purchase information.
                	PurchaseBean[] purchases = null;
                	PurchaseBean[] prevPurchases = null;
                	
                	if(xmlData!=null && xmlData.length()!=0)
                		itemBean = myParser.processXMLString(xmlData);					//Fill in the bean fields.
                	
                	///// Create a session object in case it has not been created before /////
                	if(itemBean.getBuyPrice().length() != 0)	//First, check if there is item price.
                	{
                		// Fill in the fields in the purchase bean.
                		purchaseBean.setItemID(itemBean.getItemID());
                		purchaseBean.setName(itemBean.getName());
                		purchaseBean.setBuyPrice(itemBean.getBuyPrice());
                		
                		session = request.getSession(true);				//Get the session object.
                		prevPurchases = (PurchaseBean[])session.getAttribute("purchases");
                		if(prevPurchases == null)	//Verify first-time session.
                		{
                			purchases = new PurchaseBean[1];			//Keep purchases in an array.
                			purchases[0] = purchaseBean;
                		}
                		else
                		{
                			// Copy previous purchases into another array.
                			Vector <PurchaseBean> purchasesVector = new Vector <PurchaseBean>();
                			boolean alreadyExists = false;
                			
                			for(int I = 0; I < prevPurchases.length; I++)	//Making room for new purchase.
                			{
                				purchasesVector.add(prevPurchases[I]);
                				if(prevPurchases[I].getItemID().equals(purchaseBean.getItemID()))
                					alreadyExists = true;					//Check if the item is not in the list already.
                			}
                			if(!alreadyExists)
                				purchasesVector.add(purchaseBean);			//Add new purchase object.
                			
                			purchases = new PurchaseBean[purchasesVector.size()];
                			purchasesVector.copyInto(purchases);			//Dump vector elements into array.
                		}
                		
                		// Finally, save the new array of bean purchases into the session.
                		session.setAttribute("purchases", purchases);	//This is for the tabs issue.
                	}
                	
                   	request.setAttribute("itemBean", itemBean);						//Forward a bean to a JSP.
                    request.getRequestDispatcher("itemData.jsp").forward(request, response);
                }
                else
                	response.sendRedirect("getItem.html");
        	}
        }
    }
}
