package edu.ucla.cs.cs144;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.PrintWriter;

public class PaymentServlet extends HttpServlet implements Servlet {
       
    public PaymentServlet() {}

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	PrintWriter salida = response.getWriter();
    	
    	//////////////////////////////Validate that this page is http ///////////////////////////
    	//Construct the http redirection.
    	String scheme = "http";             			// http.
        String serverName = request.getServerName();    // localhost.
        int serverPort = 8080;       					// Unsecure port.
        String contextPath = request.getContextPath();  // /eBay
        String servletPath = request.getServletPath();	// Back to unencrypted navigation.
        String query = request.getQueryString();		// Get the query parameters.
        String url = scheme + "://" + serverName+":" + serverPort + contextPath + servletPath;
        url += (query != null)? "?"+query : "";
        if(request.isSecure())							// Is request for a secure connection?
        {
        	salida.println("You will be redirected to a valid http, not cyphered, version of this page.");
        	response.sendRedirect(url);					// Load the equivalent http page.
        }
        /////////////////////////////////////////////////////////////////////////////////////////
        else
        {
        	//Check that the parameters were passed.
        	if(request.getParameter("itemID")==null)
        		response.sendRedirect("keywordSearch.html");
        		//salida.println("Null values have been received.");
        	else
        	{
        		HttpSession session = request.getSession(true);			//Get session.
        		//Check that there is at least the session already created with a purchase object.
        		if(session.getAttribute("purchases") == null)
        			response.sendRedirect("keywordSearch.html");
        		else
        		{
        			String itemID = (String)request.getParameter("itemID");	//Get item id value, which allows.
                    														//us to compare with the values in the session.
                    itemID = itemID.trim();									//Remove the spaces to left and right.
                    if(itemID.length() != 0)		//Id was provided?
                    {
                    	//At this point, we suppose that the session contain the purchase info for this id.
                    	//Construct the https connection for the submit button in the jsp.
                    	scheme = "https";             			// https.
                        serverName = request.getServerName();    // localhost.
                        serverPort = 8443;       					// Secure port.
                        contextPath = request.getContextPath();  // /eBay
                        servletPath = "/validate";  				// /validate

                        //Complete secure call to validate servlet from the jsp.
                        url = scheme + "://" + serverName+":" + serverPort + contextPath + servletPath;

                    	request.setAttribute("url", url);				//Forward composite url to validate.
                        request.getRequestDispatcher("inputPayment.jsp").forward(request, response);
                    }
                    else
                    	response.sendRedirect("keywordSearch.html");
        		}
        	}
        }	
    }
    
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	doGet(request, response);		//Redirect the Post request to a Get one.
    }
}
