package edu.ucla.cs.cs144;

import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.queryParser.ParseException;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;

public class SearchEngine 
{
	private static IndexSearcher searcher = null;		//Search engine with Lucene.
	private static QueryParser parser = null;

	/* Set a reference to the index searcher and parser, create them if do not exist */
	private static void setSearchEngine() throws IOException 
	{
		if(searcher == null || parser == null)		//Create them only once.
		{
			String directory = System.getenv("LUCENE_INDEX") + "/itemIndex";
		    searcher = new IndexSearcher(directory);
		    parser = new QueryParser("content", new StandardAnalyzer());	//Parse on the composite field by default.
		}
	}

	/* Execute the keyword search over the Lucene index */
	public static Hits performSearch(String queryString) throws IOException, ParseException
	{
		setSearchEngine();
		Query query = parser.parse(queryString);
	    Hits hits = searcher.search(query);
	    return hits;
	}
}
