package edu.ucla.cs.cs144;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.PrintWriter;

public class SearchServlet extends HttpServlet implements Servlet {
       
    public SearchServlet() {}

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	PrintWriter salida = response.getWriter();
        //Check that the parameters were passed.
    	if(request.getParameter("q")==null || request.getParameter("numResultsToSkip")==null || request.getParameter("numResultsToReturn")==null)
    		response.sendRedirect("keywordSearch.html");
    		//salida.println("Null values have been received.");
    	else
    	{
    		try
    		{
    			String q = request.getParameter("q");			//Retrieve the query keyword.
                int numResultsToSkip = Integer.parseInt(request.getParameter("numResultsToSkip"));			//Number of results to skip.
                int numResultsToReturn = Integer.parseInt(request.getParameter("numResultsToReturn"));		//Number of results to return.
                SearchResult[] searchResults;
                HttpSession session = request.getSession(true);		//Create session.
                
                q = q.trim();										//Remove the spaces to left and right.
                if(q.length() != 0)		//Keyword was provided?
                {
                	searchResults = AuctionSearchClient.basicSearch(q, numResultsToSkip, numResultsToReturn);	//Perform search.
                	
                	//Verify that search was performed correctly.
                	if(searchResults.length > 0 && searchResults[0].getItemId().equals("-1"))
                		session.setAttribute("totalResults", 0);
                	else
                	{
                		//Check that the first time, it will show the first 20 results.
                		if(numResultsToSkip == 0 && numResultsToReturn == 0)
                    		session.setAttribute("totalResults", searchResults.length);
                	}
                		
                	request.setAttribute("searchResults", searchResults);			//Forward results to a JSP.
                    request.getRequestDispatcher("searchResults.jsp").forward(request, response);
                }
                else
                	response.sendRedirect("keywordSearch.html");
    		}
    		catch(Exception e)		//Catch parsing integers exception.
    		{
    			response.sendRedirect("keywordSearch.html");
    			//salida.println("An exception happened: " + e.getMessage());
    		}
    	}
    }
}
