package edu.ucla.cs.cs144;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.PrintWriter;
import java.util.Vector;

public class SearchServlet extends HttpServlet implements Servlet {
       
    public SearchServlet() {}

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	PrintWriter salida = response.getWriter();
    	
    	////////////////////////////// Validate that this page is http ///////////////////////////
    	//Construct the http redirection.
    	String scheme = "http";             			// http.
        String serverName = request.getServerName();    // localhost.
        int serverPort = 8080;       					// Unsecure port.
        String contextPath = request.getContextPath();  // /eBay
        String servletPath = request.getServletPath();	// Back to unencrypted navigation.
        String query = request.getQueryString();		// Get the query parameters.
        String url = scheme + "://" + serverName+":" + serverPort + contextPath + servletPath;
        url += (query != null)? "?"+query : "";
        if(request.isSecure())							// Is request for a secure connection?
        {
        	salida.println("You will be redirected to a valid http, not cyphered, version of this page.");
        	response.sendRedirect(url);					// Load the equivalent http page.
        }
        /////////////////////////////////////////////////////////////////////////////////////////
        else
        {
        
	    	if(request.getParameter("q")==null || request.getParameter("numResultsToSkip")==null || request.getParameter("numResultsToReturn")==null)
	    		response.sendRedirect("keywordSearch.html");
	    		//salida.println("Null values have been received.");
	    	else
	    	{
	    		try
	    		{
	    			String q = request.getParameter("q");			//Retrieve the query keyword.
	                int numResultsToSkip = Integer.parseInt(request.getParameter("numResultsToSkip"));			//Number of results to skip.
	                int numResultsToReturn = Integer.parseInt(request.getParameter("numResultsToReturn"));		//Number of results to return.
	                SearchResult[] searchResults = null;
	                QueryBean queryBean = new QueryBean();			//To store this query total results.
	                QueryBean[] previousQueries = null;
	                QueryBean[] updatedQueries = null;
	                Vector<QueryBean> queriesVector = new Vector<QueryBean>();
	                HttpSession session = request.getSession(true);		//Create session.
	                
	                q = q.trim();										//Remove the spaces to left and right.
	                if(q.length() != 0)		//Keyword was provided?
	                {
	                	//// Verifying that num results to skip is multiple of 10 for proper display ////
	                	if(numResultsToSkip % 10 != 0)
	                		numResultsToSkip = ((int)(numResultsToSkip/10))*10;	//Round it to lower int.
	                	if(numResultsToSkip < 0)						//Negative number?
	                		numResultsToSkip *= -1;						//Change sign.
	                	
	                	//////// Verifying that numResultsToReturn is either 0 or 10 ////////
	                	if(numResultsToReturn != 0 && numResultsToReturn != 10)
	                		numResultsToReturn = 10;						//Get first results.
	                	
	                	/// Load the previous queries in the current user's session ////
	                	boolean alreadyExists = false;
	                	previousQueries = (QueryBean[])session.getAttribute("queries");
	                	for(int I=0; previousQueries!=null && I<previousQueries.length; I++)
	                	{
	                		queriesVector.add(previousQueries[I]);		//Build the vector, one by one.
	                		if(previousQueries[I].getQuery().equals(q.toLowerCase().replaceAll("( )+", " ")))	//Query is already registered?
	                			alreadyExists = true;
	                	}	//After this, queriesVector contains current queries in the session.
	                	
	                	////// If it is the first time for the query, registered its total //////
	                	if(!alreadyExists)
	                	{
	                		searchResults = AuctionSearchClient.basicSearch(q, 0, 0);	//Perform full search.
	                		queryBean.setQuery(q.toLowerCase().replaceAll("( )+", " "));
	                		if(searchResults.length > 0 && searchResults[0].getItemId().equals("-1"))
	                			queryBean.setTotalResults(0);							//Check success.
	                		else
	                			queryBean.setTotalResults(searchResults.length);		//Fill in the total.
	                		alreadyExists = true;
	                		
	                		queriesVector.add(queryBean);			//Add new query.
	                	}
	                	
	                	////// Getting the search results with properly set numResultsTo* ///////
	                	if(searchResults == null || numResultsToSkip>0)	//Check that it has not executed search before.
	                		searchResults = AuctionSearchClient.basicSearch(q, numResultsToSkip, numResultsToReturn);	//Perform search.
	                		
	                	updatedQueries = new QueryBean[queriesVector.size()];			//Create new queries vector.
	                	queriesVector.copyInto(updatedQueries);
	                	session.setAttribute("queries", updatedQueries);				//Write session object.
	                	request.setAttribute("searchResults", searchResults);			//Forward results to a JSP.
	                    request.getRequestDispatcher("searchResults.jsp").forward(request, response);
	                	//salida.println("Query: -" + q.toLowerCase().replaceAll("( )+", " ") + "-");
	                }
	                else
	                	response.sendRedirect("keywordSearch.html");
	    		}
	    		catch(Exception e)		//Catch parsing integers exception.
	    		{
	    			response.sendRedirect("keywordSearch.html");
	    			//salida.println("An exception happened: " + e.getMessage());
	    		}
	    	}
        }
    }
}
