package edu.ucla.cs.cs144;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.PrintWriter;
import java.util.Vector;

public class ValidateServlet extends HttpServlet implements Servlet {
       
    public ValidateServlet() {}

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	PrintWriter salida = response.getWriter();
    	
    	//Construct the http connection for the submit button in the jsp.
    	String scheme = "http";             			// http.
        String serverName = request.getServerName();    // localhost.
        int serverPort = 8080;       					// Secure port.
        String contextPath = request.getContextPath();  // /eBay
        String searchPath = "/keywordSearch.html";		// Back to unencrypted navigation.
        String url = scheme + "://" + serverName+":" + serverPort + contextPath + searchPath;
        
        if(!request.isSecure())	//Validate that the connection is effectively coming from inputPayment.jsp
    	{
    		salida.println("You reached this page from an insecure connection. Start the process again.");
    		response.sendRedirect(url);
    	}
        else
        {
        	//Check that the parameters were passed (they come from a jsp form in inputPayment.jsp).
        	if(request.getParameter("itemID")==null || request.getParameter("creditCard")==null)
        		response.sendRedirect(url);
        		//salida.println("Null values have been received.");
        	else
        	{
        		HttpSession session = request.getSession(true);			//Get session.
        		//Check that there is at least the session already created with a purchase object.
        		if(session.getAttribute("purchases") == null)
        			response.sendRedirect(url);
        			//salida.println("Purchases array is not in the session.");
        		else
        		{
        			String itemID = request.getParameter("itemID");		//Get item id value, which allows us to compare with the values in the session.
        			String creditCard = request.getParameter("creditCard");	//Get credit card data.
                    itemID = itemID.trim();									//Remove the spaces to left and right.
                    creditCard = creditCard.trim();
                    if(itemID.length() != 0 && creditCard.length() != 0)	//Id and credit card provided?
                    {
                    	PurchaseBean purchaseBean = new PurchaseBean();		//To store purchase information.
                    	PurchaseBean[] purchases = null;
                    	PurchaseBean[] prevPurchases = (PurchaseBean[])session.getAttribute("purchases");
                    	
                    	//Now remove the current purchase from the session.
                    	//Copy previous purchases into another array.
            			Vector <PurchaseBean> purchasesVector = new Vector <PurchaseBean>();
            			
            			for(int I = 0; I < prevPurchases.length; I++)	//Making room for new purchase.
            			{
            				if(prevPurchases[I].getItemID().equals(itemID))
            				{
            					purchaseBean.setItemID(prevPurchases[I].getItemID());
                        		purchaseBean.setName(prevPurchases[I].getName());
                        		purchaseBean.setBuyPrice(prevPurchases[I].getBuyPrice());	//Let credit card field empty.
            				}
            				else
            					purchasesVector.add(prevPurchases[I]);
            			}
            			
            			//At this point, if the itemID has already been removed, purchaseBean will be empty.
            			//The forwarding jsp will take care of showing a message for that.
            			purchases = new PurchaseBean[purchasesVector.size()];
            			purchasesVector.copyInto(purchases);			//Dump vector elements into array.

                        //Save new array of purchases.
                        session.setAttribute("purchases", purchases);
                        
                    	request.setAttribute("url", url);				//Forward composite url to unencrypted search page.
                    	request.setAttribute("purchaseBean", purchaseBean);	//Also, sen the current purchase data, which is no longer in the array.
                        request.getRequestDispatcher("confirmPayment.jsp").forward(request, response);
                    }
                    else
                    	response.sendRedirect(url);
                    	//salida.println("Either itemID or creditCard are empty.");
        		}
        	}
        }
    }
    
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
    	doGet(request, response);		//Redirect the Post request to a Get one.
    }
}
